#+TITLE:      Org Mode tools!
#+AUTHOR:     Worg people
#+EMAIL:      mdl AT imapmail DOT org
#+STARTUP:    align fold nodlcheck hidestars oddeven intestate
#+SEQ_TODO:   TODO(t) INPROGRESS(i) WAITING(w@) | DONE(d) CANCELED(c@)
#+TAGS:       Write(w) Update(u) Fix(f) Check(c)
#+LANGUAGE:   en
#+PRIORITIES: A C B
#+CATEGORY:   worg
#+OPTIONS:    H:3 num:nil toc:t \n:nil ::t |:t ^:t -:t f:t *:t tex:t d:(HIDE) tags:not-in-toc

# This file is released by its authors and contributors under the GNU
# Free Documentation license v1.3 or later, code examples are released
# under the GNU General Public License v3 or later.

This page lists external tools useful for handling Org files.

* Org-mode parsers

| Name            | Language                    | Author            | Annoncement/info  |
|-----------------+-----------------------------+-------------------+-------------------|
| [[https://github.com/200ok-ch/org-parser][org-parser]]      | JavaScript/Java/Clojure/BNF | 200ok             | [[https://200ok.ch/project/org-parser.html][homepage]]          |
| [[https://github.com/mashdot/orgile][Orgile]]          | PHP                         | [[https://github.com/mashdot][mashdot]]           | [[http://toshine.org/etc/orgile-emacs-org-mode-file-html-parser-php-publishing-tool/][this blog entry]]   |
| [[https://bitbucket.org/joebo/pico-org/src][pico-org]]        | PicoLisp                    | Joe Bogner        | [[http://thread.gmane.org/gmane.lisp.picolisp.general/3679][Message]]           |
| [[http://common-lisp.net/project/cl-org-mode/][cl-org-mode]]     | Common Lisp                 |                   |                   |
| [[http://members.optusnet.com.au/~charles57/GTD/orgnode.html][orgnode.py]]      | Python                      | Charles Cave      |                   |
| [[http://gioorgi.com/org-mode-parser/][org-mode-parser]] | nodejs                      |                   |                   |
| [[https://github.com/bjonnh/PyOrgMode][PyOrgMode]]       | Python                      | Jonathan Bisson   |                   |
| [[http://redmine.chadok.info/projects/neo][neo]]             | ?                           | Olivier Schwander | [[http://lists.gnu.org/archive/html/emacs-orgmode/2011-04/msg00598.html][Announcement]]      |
| [[http://search.cpan.org/dist/Org-Parser][Org::Parser]]     | Perl                        |                   |                   |
| [[https://github.com/bdewey/org-ruby][org-ruby]]        | Ruby                        | Brian Dewey       | [[https://orgmode.org/worg/org-tutorials/org-ruby.html][org-ruby tutorial]] |
| [[https://github.com/mooz/org-js][org-js]]          | JavaScript                  | Masafumi Oyamada  | [[http://mooz.github.com/org-js/editor/][working example]]   |
| [[https://github.com//xiaoxinghu/orgajs][orga]]            | ?                           | Xiaoxing Hu       |                   |
| [[https://github.com/mclements/ascii][ascii]]           | R                           |                   | [[https://cran.r-project.org/web/packages/ascii/][ascii on CRAN]]     |
| [[https://github.com/orgapp/orgajs][orgajs]]          | JavaScript                  |                   |                   |
| [[https://github.com/org-rs/org-rs][org-rs]]          | Rust                        |                   |                   |
| [[https://github.com/orgapp/swift-org][swift-org]]       | Swift                       |                   |                   |
| [[https://github.com/seylerius/organum][organum]]         | Clojure                     |                   |                   |
| [[https://github.com/eigenhombre/clj-org][clj-org]]         | Clojure                     |                   |                   |
| [[https://github.com/ixmatus/orgmode-parse][orgmode-parse]]   | ?                           |                   |                   |
| [[https://hackage.haskell.org/package/org-mode][org-mode]]        | Haskell                     |                   |                   |
| [[https://github.com/PoiScript/orgize][orgize]]          | Rust                        |                   |                   |

* Org-mode exporters

- https://github.com/zzamboni/ox-leanpub

* Specific purpose tools

** [[https://pandoc.org][pandoc]]

Pandoc is the Swiss-army knife to convert files from one markup format
into another, it can convert documents from many source format,
including Org, to many other.
** orgutils R package

- Author: Enrico Schumann
- Homepage: https://cran.r-project.org/web/packages/orgutils/

#+begin_quote
Helper functions for Org files (<http://orgmode.org/>): a generic function 'toOrg' for transforming R objects into Org markup (most useful for data frames; there are also methods for Dates/POSIXt) and a function to read Org tables into data frames.
#+end_quote

- Description and examples
Convert data.frames into org tables.

#+begin_src R :results output :session *R*
library(orgutils)
toOrg(head(mtcars))
#+end_src

#+RESULTS:
: | row.names         |  mpg | cyl | disp |  hp | drat |    wt |  qsec | vs | am | gear | carb |
: |-------------------+------+-----+------+-----+------+-------+-------+----+----+------+------|
: | Mazda RX4         |   21 |   6 |  160 | 110 |  3.9 |  2.62 | 16.46 |  0 |  1 |    4 |    4 |
: | Mazda RX4 Wag     |   21 |   6 |  160 | 110 |  3.9 | 2.875 | 17.02 |  0 |  1 |    4 |    4 |
: | Datsun 710        | 22.8 |   4 |  108 |  93 | 3.85 |  2.32 | 18.61 |  1 |  1 |    4 |    1 |
: | Hornet 4 Drive    | 21.4 |   6 |  258 | 110 | 3.08 | 3.215 | 19.44 |  1 |  0 |    3 |    1 |
: | Hornet Sportabout | 18.7 |   8 |  360 | 175 | 3.15 |  3.44 | 17.02 |  0 |  0 |    3 |    2 |
: | Valiant           | 18.1 |   6 |  225 | 105 | 2.76 |  3.46 | 20.22 |  1 |  0 |    3 |    1 |
** ascii R package

- Authors: David Hajage [aut], Mark Clements [cre, ctb], Seth Falcon [ctb], Terry Therneau [ctb], Matti Pastell [ctb], Friedrich Leisch [ctb]
- Homepage: https://cran.r-project.org/web/packages/ascii/, https://github.com/mclements/ascii

#+begin_quote
Coerce R object to 'asciidoc', 'txt2tags', 'restructuredText', 'org', 'textile' or 'pandoc' syntax. Package comes with a set of drivers for 'Sweave'.
#+end_quote
- Description and examples
Convert several R objects like tables, data.frame matrices into org tables
#+begin_src R :results output :session *R*
library(ascii)
print(ascii(head(mtcars)),type='org')
#+end_src

#+RESULTS:
: |                   | mpg   | cyl  | disp   | hp     | drat | wt   | qsec  | vs   | am   | gear | carb |
: |-------------------+-------+------+--------+--------+------+------+-------+------+------+------+------|
: | Mazda RX4         | 21.00 | 6.00 | 160.00 | 110.00 | 3.90 | 2.62 | 16.46 | 0.00 | 1.00 | 4.00 | 4.00 |
: | Mazda RX4 Wag     | 21.00 | 6.00 | 160.00 | 110.00 | 3.90 | 2.88 | 17.02 | 0.00 | 1.00 | 4.00 | 4.00 |
: | Datsun 710        | 22.80 | 4.00 | 108.00 | 93.00  | 3.85 | 2.32 | 18.61 | 1.00 | 1.00 | 4.00 | 1.00 |
: | Hornet 4 Drive    | 21.40 | 6.00 | 258.00 | 110.00 | 3.08 | 3.21 | 19.44 | 1.00 | 0.00 | 3.00 | 1.00 |
: | Hornet Sportabout | 18.70 | 8.00 | 360.00 | 175.00 | 3.15 | 3.44 | 17.02 | 0.00 | 0.00 | 3.00 | 2.00 |
: | Valiant           | 18.10 | 6.00 | 225.00 | 105.00 | 2.76 | 3.46 | 20.22 | 1.00 | 0.00 | 3.00 | 1.00 |

#+begin_src R :results output :session *R*
print(ascii(table(mtcars$am,mtcars$gear)),type='org')
#+end_src

#+RESULTS:
: |   | 3     | 4    | 5    |
: |---+-------+------+------|
: | 0 | 15.00 | 4.00 | 0.00 |
: | 1 | 0.00  | 8.00 | 5.00 |

#+begin_src R :results output :session *R*
print(ascii(as.matrix(head(mtcars))),type='org')
#+end_src

#+RESULTS:
: | 21.00 | 6.00 | 160.00 | 110.00 | 3.90 | 2.62 | 16.46 | 0.00 | 1.00 | 4.00 | 4.00 |
: | 21.00 | 6.00 | 160.00 | 110.00 | 3.90 | 2.88 | 17.02 | 0.00 | 1.00 | 4.00 | 4.00 |
: | 22.80 | 4.00 | 108.00 | 93.00  | 3.85 | 2.32 | 18.61 | 1.00 | 1.00 | 4.00 | 1.00 |
: | 21.40 | 6.00 | 258.00 | 110.00 | 3.08 | 3.21 | 19.44 | 1.00 | 0.00 | 3.00 | 1.00 |
: | 18.70 | 8.00 | 360.00 | 175.00 | 3.15 | 3.44 | 17.02 | 0.00 | 0.00 | 3.00 | 2.00 |
: | 18.10 | 6.00 | 225.00 | 105.00 | 2.76 | 3.46 | 20.22 | 1.00 | 0.00 | 3.00 | 1.00 |

** org-webring - generate webrings for Org-based sites / blogs

- Read [[https://brettgilio.com/posts/2020-08-20-announcing-org-webring.html][the announcement]] and [[https://list.orgmode.org/875z9c4ltr.fsf@gnu.org/][the message sent to the Org-mode list]]
- Browse [[https://sr.ht/~brettgilio/org-webring][the project page and source code]]
- Participate in [[https://sr.ht/~brettgilio/org-webring/lists][the mailing list]]

** [[https://github.com/tecosaur/org-pandoc-import][org-pandoc-import]] : leverage Pandoc to convert selected file types to org
** [[https://github.com/tumashu/el2org][el2org]] - convert an emacs-lisp file to an org file
** [[https://github.com/legalnonsense/elgantt/][El Gantt]] - A Gantt chart/calendar for Orgmode
** [[https://org-web.org/][org-web.org]] -  - org mode on the web

See https://github.com/DanielDe/org-web

** organice - organice organizes Org files nicely!

[[https://github.com/200ok-ch/organice][organice]] is an implementation of Org mode without the dependency of
Emacs. It is built for mobile and desktop browsers and syncs with
Dropbox, Google Drive and WebDAV.

** orgmode for Drupal

[[https://www.drupal.org/project/orgmode][Orgmode for drupal]] import org files into drupal nodes. 

** nakkaya: a static site generator parsing Org's files (and MarkDown)

Static is a simple static site generator written in Clojure.  For a
sample site build using static see http://nakkaya.com

You can grab the latest version of nakkaya from [[https://github.com/nakkaya/static][its github repository]].

** orgitdown - use Org keybindings in HTML text areas

[[https://github.com/gnowgi/orgitdown][orgitdown]] is based on [[http://markitup.jaysalvat.com/home/][markitup]] and allows to use Org keybindings in
text areas through some javascript magic.  The text inserted is using
Org's syntax, and can be further processed with Emacs in batch mode on
the server.

Check [[http://mid.gmane.org/CADSSMeg5BDkZMBWEhXF2K7kssrEsX6SkZE%2BOjvXFpHY5aTcgmQ@mail.gmail.com][Nagarjuna G announcement on the mailing list]].

** Exporter for the Octopress blogging engine

#+BEGIN_QUOTE
Octopress is a framework designed by Brandon Mathis for Jekyll, the blog
aware static site generator powering Github Pages. To start blogging with
Jekyll, you have to write your own HTML templates, CSS, Javascripts and set
up your configuration. But with Octopress All of that is already taken care
of. Simply clone or fork Octopress, install dependencies and the theme, and
you’re set.
#+END_QUOTE

You can clone Octopress from [[https://github.com/imathis/octopress][the github repository]].

[[https://github.com/craftkiller/orgmode-octopress][orgmode-octopress]] is an exporter for Emacs Org-Mode to Octopress by
craftkiller.  For setup instructions, check [[http://blog.paphus.com/blog/2012/08/01/introducing-octopress-blogging-for-org-mode/][this blog entry]].  Note that
orgmode-octopress will not work with the new export engine in Org 8.0.

** Export OmniFocus to Org-mode files

Jay McCarthy wrote [[https://github.com/jeapostrophe/exp/blob/master/of2org.rkt][this]], using [[http://racket-lang.org/][Racket]].

** Convert from Planner to Org

See this message from [[http://mid.gmane.org/8ay5hehupe.fsf@faepop01.tu-graz.ac.at][Andreas Hirczy]]:

I have written yet another converter from planner to org:
<http://itp.tugraz.at/~ahi/Computer/SW/muse2org.html>
<http://itp.tugraz.at/~ahi/Computer/SW/muse2org>

** Export vCard to org-mode entries

[[http://mid.gmane.org/50B28EA7.6020900@gmx.de][Simon Thum]] shared some [[https://gist.github.com/4145201][Ruby code]] to export vCards to Org-mode entries.

** ews-orgmode - Exchange calendar to orgmode

https://github.com/kautsig/ews-orgmode

See [[http://mid.gmane.org/50B78A90.3040609@kautsig.org][this message]] from Chris Raschl:

: I recently wrote a python script to fetch my calendar from the corporate
: exchange server into an orgmode file to view it in my agenda.
: It uses the exchange webservices (ews).

** michel-orgmode - script for pushing to / pulling from Google-Tasks lists

- Authors: Mark Edgington, Christophe-Marie Duquesne
- Homepage: https://bitbucket.org/edgimar/michel-orgmode

Michel-orgmode is a python script which serves as a bridge between an
org-mode textfile and a Google-tasks task list.  It can pull the contents
of a Google-tasks list into an org-mode file, or push an org-mode file's
contents to a Google-tasks list.  It supports bidirectional sync.

** Using GData API to import events in an Org file

Mon, 11 Jul 2011, Felix Geller wrote:

: I wrote a Python [[https://bitbucket.org/fgeller/gcal2org/src/8fa7d2b83ab3/gcal2org.py][script]] that uses the GData API to download events for your
: Google Calendar and prints them to a given org-file. It is a very tiny
: script, but perhaps it is of use to other people as well.
:
: Small disclaimer: I've tested this on Mac OS X only, using Python 2.7.2.

The script can be found here: [[https://bitbucket.org/fgeller/gcal2org/src/8fa7d2b83ab3/gcal2org.py][gcal2org.py]]

** Migrating from Tomboy to Org

In [[https://list.orgmode.org/4E36EF1D.7000307@stalphonsos.com][this email]], Attila shared a script to move notes from Tomboy to
Org-mode -- see his message:

: I'm moving my note-taking from GNote (C++ rewrite of Tomboy Notes) to
: org-mode.  As I have a lot of notes all over the place, I wrote a script to
: convert from the XML format used by the Tomboy-style tools to org-mode.

You can find the script here: https://github.com/StAlphonsos/scriptologie

** orgutil - TCL script to manipulate org files

- Author: Patrick Brennan
- Homepage: http://sourceforge.net/projects/orgutil/

: Script for converting files into and out of Org-mode, and for performing
: various analyses and conversions. The primary use case for this utility is
: to convert between Org-mode outline text and AbstractSpoon's ToDoList.

** org2remind - perl script to convert org appointments to remind

 - Author: Matt Lundin
 - Code: [[file:../code/perl/org2remind.pl][org2remind]]

Remind is a command line calendar application for Unix/Linux that
can, among other things, spit out formatted plain text calendars and
agendas.

http://www.roaringpenguin.com/products/remind

: To convert org-mode appointments to remind data, simply call the
: script on one or more org files:
: 
: perl org2remind.pl ~/org/*.org
: 
: (Optionally, add the script to your path and make it executable.)
: 
: The results of this script can saved in a file...
: 
: perl org2remind.pl ~/org/*.org >> org.rem 
: 
: ...or piped directly into a remind command...
: 
: perl org2remind.pl ~/org/*.org | remind -
: 
: For a nice calendar of the current month, use the following: 
: 
: perl org2remind.pl ~/org/*.org | remind -c -
: 
: This script is similar to org2rem.el (in the contrib directory of the
: org-mode repository), except that, instead of saving files from within
: org-mode, it allows for easier and faster access to org/remind data
: from the command line.
: 
: Currently, the script supports appointments (i.e., active timestamps)
: and the org-diary-class sexp.
** ical2org.awk - convert ics files to Org

- Author: Eric S Fraga
- Code: [[https://github.com/msherry/ical2org/blob/master/ical2org.awk][ical2org.awk]]

See [[file:../org-tutorials/org-google-sync.org][the org-google-sync tutorial]] for explanations on how to use this
script.

** ical2org.rb - convert ics files to Org
   - Author: Simon Thum
   - Code: [[https://github.com/simonthum/ical2org][ical2org]]
   - handles events and TODOs
   - all sorts of repeating events
   - and timezones!
   - one-way only though
     - except if you have a REST-capable ical server, see README
** org-manage - locate and manage your org files
    - Author: Daniel German
    - Code:   [[http://github.com/dmgerman/org-manage][org-manage]] (based on [[https://github.com/yoshinari-nomura/org-octopress][org-octopress]])
    - Lists all org files in a given directory and its subdirectories,
      providing a table of org files, including their title and category.

#+begin_quote
This is a module to help managing a large collection of org files. It
is based on org-octopress by Yoshinari Nomura.

org-manage scans a given directory (recursively) looking for org
files. For each, an entry is created. The title is extracted from the
attribute #+TITLE: in the org file. The category is extracted from the
first #+CATEGORY in the file (I suggest you add a default category to
each file.
#+end_quote

** vimwiki2org - convert vimwiki files to Org
   - Author: Xu FaSheng
   - Homepage: https://github.com/fasheng/vimwiki2org

** Org Blog Wiki tools

See the page [[file:../org-blog-wiki.org][Org Blogs and Wikis]].

** orgFixLinks.py: a Python command-line utility for repairing broken links to local files
  :PROPERTIES:
  :CUSTOM_ID: fix-links
  :END:

    - Author: GitHub user cashTangoTangoCash
    - website: https://github.com/cashTangoTangoCash/orgFixLinks
    - repairs broken links in org files
    - currently Linux-only, but probably straighforward to port to Win/Mac?

#+begin_quote
 A stand-alone Python script designed to interactively repair broken
links to local files in one, many, or all of your org files.  OK, it's
an amateur command line script that likely needs more refinement, and
it chooses to do things that not everyone desires, but you can fork it
on GitHub, and adapt it to your own purposes.  If you are frustrated
by broken links to the degree that you are ready to debug a lengthy
Python script, why not play with it.  The GitHub wiki
https://github.com/cashTangoTangoCash/orgFixLinks/wiki provides a
degree of documentation.
#+end_quote
